From 3eda0dd861fc43d2637c61cf4fd67705e13366de Mon Sep 17 00:00:00 2001
From: Michael Neumann <mneumann@ntecs.de>
Date: Thu, 10 Oct 2024 10:55:04 +0200
Subject: [PATCH] Retire crypto(9) and tcplay(8) and refactor dm_target_crypt

* Completely remove the OpenBSD-inherited in-kernel crypto(9) framework
  that lived in sys/crypto and hardware drivers in dev/crypto. With it,
  remove /dev/crypto - the only application relying on it in DragonFly
  was tcplay...

* Remove tcplay(8). It was severly broken and could panic the kernel by
  exceeding the malloc limits; see https://bugs.dragonflybsd.org/issues/3370

* Remove hifn(4), safe(4), ubsec(4) and padlock(4) drivers. These  were
  removed in OpenBSD 7.1 and it's unlikely that they are still in use by
  someone.

* In-place of crypto(9), add a simple non-allocating API that lives in
  crypto_ciphers.{h,c}. It's only used by dm_target_crypt.

* Remove support for the following crypto algorithms:

  Blowfish, Camellia, Cast, Serpent, Skipjack, Twofish

  Mainly, because I am too lazy to test any of these with
  dm_target_crypt, but also, because there is no hardware support for
  any of these.

* Greatly refactor dm_target_crypt. It used to encrypt/decrypt blocks in
  pieces of 512 bytes and send them over to the async crypto(9) framework.
  The async-ness of crypto(9) led to overly complex code. The new
  code processes each BIO read or write request by a worker thread.
  There are ncpu kthreads to process read requests, and another
  set of ncpu kthreads to process write requests. Instead of using a
  malloc_pipe as before, and allocating memory for each BIO request
  from that mpipe, each worker kthread now simply owns the required
  memory. That being said, it is 100% non-allocating.
  The BIO requests are distributing to the worker threads round robin.
  Performance-wise it is about the same speed as before, slightly better,
  whereas interactivity is a lot better now - mainly concerning the mouse
  cursor, which keeps on moving rather smooth, even under higher load.
  Under very high I/O, the rest of the system still because very slow,
  but the same happens without dm_target_crypt.
  Note that I test using a rather old i5-8350U Panasoci laptop that
  still has SATA SSD.

* The AESNI (hardware instruction for AES as found in most Intel/AMD CPUs)
  code moved from dev/aesni to crypto/. It is no longer a device.
  We simply check for the CPU feature when "probing" for available
  crypto ciphers. Note that by default, the hardware-accelerated
  ciphers (AES-CBC, AES-XTS) are prefered over the software
  implementation. You can disable aesni by setting sysctl
  hw.aesni_disable=1. Note that, setting this will not have immediate
  effect for already "mounted" dm_target_crypt targets, as the crypto
  cipher is queried only at attach time.

* Use explicit_bzero in a few places.

* I've tested both AES-CBC and AES-XTS with and w/o AESNI. Basically, I
  formatted a device (cryptsetup luksFormat) with the old kernel, write
  some data on it, then switched to the new kernel, and tried to open it.
---
 Makefile_upgrade.inc                          |   17 +
 UPDATING                                      |   15 +
 contrib/mdocml/lib.in                         |    1 -
 initrd/etc/Makefile                           |    2 +-
 initrd/etc/rcmount_tcplay                     |    9 -
 initrd/rescue.libcrypto/Makefile              |    5 +-
 lib/Makefile                                  |    1 -
 lib/libtcplay/Makefile                        |   33 -
 lib/libtcplay/crc32.c                         |  109 -
 lib/libtcplay/crc32.h                         |    2 -
 lib/libtcplay/crypto-dev.c                    |  165 -
 lib/libtcplay/crypto.c                        |  267 --
 lib/libtcplay/generic_xts.c                   |  175 -
 lib/libtcplay/generic_xts.h                   |   49 -
 lib/libtcplay/hdr.c                           |  432 ---
 lib/libtcplay/humanize.c                      |  199 --
 lib/libtcplay/humanize.h                      |   32 -
 lib/libtcplay/io.c                            |  466 ---
 lib/libtcplay/pbkdf2-openssl.c                |   61 -
 lib/libtcplay/safe_mem.c                      |  196 --
 lib/libtcplay/tcplay.3                        |  564 ----
 lib/libtcplay/tcplay.c                        | 2215 -------------
 lib/libtcplay/tcplay.h                        |  352 --
 lib/libtcplay/tcplay.map                      |   15 -
 lib/libtcplay/tcplay_api.c                    |  806 -----
 lib/libtcplay/tcplay_api.h                    |   75 -
 lib/libtcplay/tcplay_api_internal.h           |   52 -
 sbin/Makefile                                 |    1 -
 sbin/cryptdisks/Makefile                      |    4 +-
 sbin/cryptdisks/cryptdisks.8                  |    4 +-
 sbin/cryptdisks/cryptdisks.c                  |  103 +-
 sbin/tcplay/Makefile                          |   28 -
 sbin/tcplay/main.c                            |  480 ---
 sbin/tcplay/tcplay.8                          |  570 ----
 share/man/man4/Makefile                       |    6 -
 share/man/man4/aesni.4                        |    4 +-
 share/man/man4/crypto.4                       |  135 -
 share/man/man4/dm_target_crypt.4              |    1 -
 share/man/man4/hifn.4                         |  130 -
 share/man/man4/padlock.4                      |   97 -
 share/man/man4/rdrand.4                       |    1 -
 share/man/man4/rndtest.4                      |    4 -
 share/man/man4/safe.4                         |  126 -
 share/man/man4/ubsec.4                        |  104 -
 share/man/man7/initrd.7                       |   16 +-
 share/man/man9/Makefile                       |    9 -
 share/man/man9/crypto.9                       |  329 +-
 share/mk/bsd.libnames.mk                      |    1 -
 sys/conf/files                                |   27 +-
 sys/conf/kmod.mk                              |    2 +-
 sys/conf/options                              |   15 -
 sys/config/LINT64                             |   20 +-
 sys/config/X86_64_GENERIC                     |    3 -
 sys/crypto/Makefile                           |   27 +-
 sys/{dev => }/crypto/aesni/aesencdec_x86_64.S |    0
 sys/{dev => }/crypto/aesni/aeskeys_x86_64.S   |    0
 sys/crypto/aesni/aesni.c                      |  384 +++
 sys/crypto/aesni/aesni.h                      |   71 +
 sys/crypto/blowfish/bf_enc.c                  |  155 -
 sys/crypto/blowfish/bf_locl.h                 |  173 -
 sys/crypto/blowfish/bf_pi.h                   |  328 --
 sys/crypto/blowfish/bf_skey.c                 |  118 -
 sys/crypto/blowfish/blowfish.h                |   93 -
 sys/crypto/camellia/camellia-api.c            |   56 -
 sys/crypto/camellia/camellia.c                | 1332 --------
 sys/crypto/camellia/camellia.h                |   69 -
 sys/crypto/crypto_cipher.c                    |  389 +++
 sys/crypto/crypto_cipher.h                    |   54 +
 sys/crypto/crypto_mod.c                       |   42 +
 sys/{opencrypto => crypto/rmd160}/rmd160.c    |    2 +-
 sys/{opencrypto => crypto/rmd160}/rmd160.h    |    0
 sys/crypto/serpent/serpent.c                  |  631 ----
 sys/crypto/serpent/serpent.h                  |   16 -
 sys/crypto/twofish/twofish.c                  |  514 ---
 sys/crypto/twofish/twofish.h                  |   16 -
 sys/dev/crypto/Makefile                       |    2 +-
 sys/dev/crypto/aesni/Makefile                 |    8 -
 sys/dev/crypto/aesni/aesni.c                  |  353 --
 sys/dev/crypto/aesni/aesni.h                  |  103 -
 sys/dev/crypto/aesni/aesni_wrap.c             |  331 --
 sys/dev/crypto/cryptodev/Makefile             |    7 -
 sys/dev/crypto/hifn/Makefile                  |   13 -
 sys/dev/crypto/hifn/hifn7751.c                | 2938 -----------------
 sys/dev/crypto/hifn/hifn7751reg.h             |  590 ----
 sys/dev/crypto/hifn/hifn7751var.h             |  365 --
 sys/dev/crypto/padlock/Makefile               |    8 -
 sys/dev/crypto/padlock/padlock.c              |  427 ---
 sys/dev/crypto/padlock/padlock.h              |  101 -
 sys/dev/crypto/padlock/padlock_cipher.c       |  266 --
 sys/dev/crypto/padlock/padlock_hash.c         |  388 ---
 sys/dev/crypto/padlock/padlock_rng.c          |   78 -
 sys/dev/crypto/padlock/rng_harvest_x86_64.S   |   75 -
 sys/dev/crypto/safe/Makefile                  |   39 -
 sys/dev/crypto/safe/safe.c                    | 2248 -------------
 sys/dev/crypto/safe/safereg.h                 |  412 ---
 sys/dev/crypto/safe/safevar.h                 |  219 --
 sys/dev/crypto/ubsec/Makefile                 |   13 -
 sys/dev/crypto/ubsec/ubsec.c                  | 2856 ----------------
 sys/dev/crypto/ubsec/ubsecreg.h               |  221 --
 sys/dev/crypto/ubsec/ubsecvar.h               |  256 --
 sys/dev/disk/dm/crypt/Makefile                |    4 +-
 sys/dev/disk/dm/crypt/dm_target_crypt.c       | 1379 ++++----
 sys/dev/raid/arcmsr/arcmsr.h                  |    1 +
 sys/opencrypto/cast.c                         |  242 --
 sys/opencrypto/cast.h                         |   23 -
 sys/opencrypto/castsb.h                       |  545 ---
 sys/opencrypto/criov.c                        |  197 --
 sys/opencrypto/crypto.c                       | 1651 ---------
 sys/opencrypto/cryptodev.c                    |  930 ------
 sys/opencrypto/cryptodev.h                    |  462 ---
 sys/opencrypto/cryptodev_if.m                 |   55 -
 sys/opencrypto/cryptosoft.c                   | 1433 --------
 sys/opencrypto/cryptosoft.h                   |   69 -
 sys/opencrypto/deflate.c                      |  174 -
 sys/opencrypto/deflate.h                      |   56 -
 sys/opencrypto/gmac.c                         |  159 -
 sys/opencrypto/gmac.h                         |   51 -
 sys/opencrypto/skipjack.c                     |  258 --
 sys/opencrypto/skipjack.h                     |   19 -
 sys/opencrypto/xform.c                        | 1099 ------
 sys/opencrypto/xform.h                        |  119 -
 sys/platform/pc64/conf/files                  |   13 +-
 sys/platform/vkernel64/conf/files             |    1 -
 tools/tools/crypto/Makefile                   |   63 -
 tools/tools/crypto/README                     |   45 -
 tools/tools/crypto/cryptokeytest.c            |  287 --
 tools/tools/crypto/cryptostats.c              |  105 -
 tools/tools/crypto/cryptotest.c               |  622 ----
 tools/tools/crypto/hifnstats.c                |   61 -
 tools/tools/crypto/ubsecstats.c               |   69 -
 130 files changed, 1602 insertions(+), 33912 deletions(-)
 delete mode 100644 initrd/etc/rcmount_tcplay
 delete mode 100644 lib/libtcplay/Makefile
 delete mode 100644 lib/libtcplay/crc32.c
 delete mode 100644 lib/libtcplay/crc32.h
 delete mode 100644 lib/libtcplay/crypto-dev.c
 delete mode 100644 lib/libtcplay/crypto.c
 delete mode 100644 lib/libtcplay/generic_xts.c
 delete mode 100644 lib/libtcplay/generic_xts.h
 delete mode 100644 lib/libtcplay/hdr.c
 delete mode 100644 lib/libtcplay/humanize.c
 delete mode 100644 lib/libtcplay/humanize.h
 delete mode 100644 lib/libtcplay/io.c
 delete mode 100644 lib/libtcplay/pbkdf2-openssl.c
 delete mode 100644 lib/libtcplay/safe_mem.c
 delete mode 100644 lib/libtcplay/tcplay.3
 delete mode 100644 lib/libtcplay/tcplay.c
 delete mode 100644 lib/libtcplay/tcplay.h
 delete mode 100644 lib/libtcplay/tcplay.map
 delete mode 100644 lib/libtcplay/tcplay_api.c
 delete mode 100644 lib/libtcplay/tcplay_api.h
 delete mode 100644 lib/libtcplay/tcplay_api_internal.h
 delete mode 100644 sbin/tcplay/Makefile
 delete mode 100644 sbin/tcplay/main.c
 delete mode 100644 sbin/tcplay/tcplay.8
 delete mode 100644 share/man/man4/crypto.4
 delete mode 100644 share/man/man4/hifn.4
 delete mode 100644 share/man/man4/padlock.4
 delete mode 100644 share/man/man4/safe.4
 delete mode 100644 share/man/man4/ubsec.4
 rename sys/{dev => }/crypto/aesni/aesencdec_x86_64.S (100%)
 rename sys/{dev => }/crypto/aesni/aeskeys_x86_64.S (100%)
 create mode 100644 sys/crypto/aesni/aesni.c
 create mode 100644 sys/crypto/aesni/aesni.h
 delete mode 100644 sys/crypto/blowfish/bf_enc.c
 delete mode 100644 sys/crypto/blowfish/bf_locl.h
 delete mode 100644 sys/crypto/blowfish/bf_pi.h
 delete mode 100644 sys/crypto/blowfish/bf_skey.c
 delete mode 100644 sys/crypto/blowfish/blowfish.h
 delete mode 100644 sys/crypto/camellia/camellia-api.c
 delete mode 100644 sys/crypto/camellia/camellia.c
 delete mode 100644 sys/crypto/camellia/camellia.h
 create mode 100644 sys/crypto/crypto_cipher.c
 create mode 100644 sys/crypto/crypto_cipher.h
 create mode 100644 sys/crypto/crypto_mod.c
 rename sys/{opencrypto => crypto/rmd160}/rmd160.c (99%)
 rename sys/{opencrypto => crypto/rmd160}/rmd160.h (100%)
 delete mode 100644 sys/crypto/serpent/serpent.c
 delete mode 100644 sys/crypto/serpent/serpent.h
 delete mode 100644 sys/crypto/twofish/twofish.c
 delete mode 100644 sys/crypto/twofish/twofish.h
 delete mode 100644 sys/dev/crypto/aesni/Makefile
 delete mode 100644 sys/dev/crypto/aesni/aesni.c
 delete mode 100644 sys/dev/crypto/aesni/aesni.h
 delete mode 100644 sys/dev/crypto/aesni/aesni_wrap.c
 delete mode 100644 sys/dev/crypto/cryptodev/Makefile
 delete mode 100644 sys/dev/crypto/hifn/Makefile
 delete mode 100644 sys/dev/crypto/hifn/hifn7751.c
 delete mode 100644 sys/dev/crypto/hifn/hifn7751reg.h
 delete mode 100644 sys/dev/crypto/hifn/hifn7751var.h
 delete mode 100644 sys/dev/crypto/padlock/Makefile
 delete mode 100644 sys/dev/crypto/padlock/padlock.c
 delete mode 100644 sys/dev/crypto/padlock/padlock.h
 delete mode 100644 sys/dev/crypto/padlock/padlock_cipher.c
 delete mode 100644 sys/dev/crypto/padlock/padlock_hash.c
 delete mode 100644 sys/dev/crypto/padlock/padlock_rng.c
 delete mode 100644 sys/dev/crypto/padlock/rng_harvest_x86_64.S
 delete mode 100644 sys/dev/crypto/safe/Makefile
 delete mode 100644 sys/dev/crypto/safe/safe.c
 delete mode 100644 sys/dev/crypto/safe/safereg.h
 delete mode 100644 sys/dev/crypto/safe/safevar.h
 delete mode 100644 sys/dev/crypto/ubsec/Makefile
 delete mode 100644 sys/dev/crypto/ubsec/ubsec.c
 delete mode 100644 sys/dev/crypto/ubsec/ubsecreg.h
 delete mode 100644 sys/dev/crypto/ubsec/ubsecvar.h
 delete mode 100644 sys/opencrypto/cast.c
 delete mode 100644 sys/opencrypto/cast.h
 delete mode 100644 sys/opencrypto/castsb.h
 delete mode 100644 sys/opencrypto/criov.c
 delete mode 100644 sys/opencrypto/crypto.c
 delete mode 100644 sys/opencrypto/cryptodev.c
 delete mode 100644 sys/opencrypto/cryptodev.h
 delete mode 100644 sys/opencrypto/cryptodev_if.m
 delete mode 100644 sys/opencrypto/cryptosoft.c
 delete mode 100644 sys/opencrypto/cryptosoft.h
 delete mode 100644 sys/opencrypto/deflate.c
 delete mode 100644 sys/opencrypto/deflate.h
 delete mode 100644 sys/opencrypto/gmac.c
 delete mode 100644 sys/opencrypto/gmac.h
 delete mode 100644 sys/opencrypto/skipjack.c
 delete mode 100644 sys/opencrypto/skipjack.h
 delete mode 100644 sys/opencrypto/xform.c
 delete mode 100644 sys/opencrypto/xform.h
 delete mode 100644 tools/tools/crypto/Makefile
 delete mode 100644 tools/tools/crypto/README
 delete mode 100644 tools/tools/crypto/cryptokeytest.c
 delete mode 100644 tools/tools/crypto/cryptostats.c
 delete mode 100644 tools/tools/crypto/cryptotest.c
 delete mode 100644 tools/tools/crypto/hifnstats.c
 delete mode 100644 tools/tools/crypto/ubsecstats.c

diff --git a/Makefile_upgrade.inc b/Makefile_upgrade.inc
index c28c9af808..7a1c3f1f59 100644
--- a/Makefile_upgrade.inc
+++ b/Makefile_upgrade.inc
@@ -3929,6 +3929,23 @@ TO_REMOVE+=/etc/mail/mailer.conf.dma
 TO_REMOVE+=/etc/mail/mailer.conf.opensmtpd
 TO_REMOVE+=/etc/mail/mailer.conf.postfix
 TO_REMOVE+=/etc/mail/mailer.conf.sendmail
+TO_REMOVE+=/usr/share/man/man4/hifn.4.gz
+TO_REMOVE+=/usr/share/man/man4/padlock.4.gz
+TO_REMOVE+=/usr/share/man/man4/safe.4.gz
+TO_REMOVE+=/usr/share/man/man4/ubsec.4.gz
+TO_REMOVE+=/usr/share/man/man4/crypto.4.gz
+TO_REMOVE+=/usr/share/man/man4/cryptodev.4.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_find_device_byhid.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_find_driver.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_get_caps.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_freereq.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_getreq.9.gz
+TO_REMOVE+=/usr/share/man/man9/crypto_unblock.9.gz
+TO_REMOVE+=/usr/lib/libtcplay.so.3
+TO_REMOVE+=/usr/lib/libtcplay.so
+TO_REMOVE+=/usr/lib/libtcplay.a
+TO_REMOVE+=/usr/share/man/man8/tcplay.8.gz
+TO_REMOVE+=/sbin/tcplay
 
 .if !defined(WANT_INSTALLER)
 TO_REMOVE+=/usr/sbin/dfuibe_installer
diff --git a/UPDATING b/UPDATING
index 72ec730267..228f5e93e9 100644
--- a/UPDATING
+++ b/UPDATING
@@ -8,6 +8,21 @@
 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
 # mailing list with the details.
 
++-----------------------------------------------------------------------+
++         UPGRADING DRAGONFLY FROM 6.4 TO LATER VERSIONS                +
++-----------------------------------------------------------------------+
+
+PADLOCK CRYPTO DRIVER REMOVED
+-----------------------------
+
+Likely no VIA cpus in use on DragonFly.
+
+HIFN, SAFE AND UBSEC CRYPTO DRIVERS REMOVED
+-------------------------------------------
+
+These were removed in OpenBSD 7.1 and it's unlikely that they are still
+in use by someone.
+
 +-----------------------------------------------------------------------+
 +         UPGRADING DRAGONFLY FROM 6.0 TO LATER VERSIONS                +
 +-----------------------------------------------------------------------+
diff --git a/contrib/mdocml/lib.in b/contrib/mdocml/lib.in
index 07f37b7296..a8bac59a4c 100644
--- a/contrib/mdocml/lib.in
+++ b/contrib/mdocml/lib.in
@@ -124,7 +124,6 @@ LINE("libstdthreads",	"C11 Threads Library (libstdthreads, \\-lstdthreads)")
 LINE("libSystem",	"System Library (libSystem, \\-lSystem)")
 LINE("libsysdecode",	"System Argument Decoding Library (libsysdecode, \\-lsysdecode)")
 LINE("libtacplus",	"TACACS+ Client Library (libtacplus, \\-ltacplus)")
-LINE("libtcplay",	"TrueCrypt-compatible API library (libtcplay, \\-ltcplay)")
 LINE("libtermcap",	"Termcap Access Library (libtermcap, \\-ltermcap)")
 LINE("libterminfo",	"Terminal Information Library (libterminfo, \\-lterminfo)")
 LINE("libthr",		"1:1 Threading Library (libthr, \\-lthr)")
diff --git a/initrd/etc/Makefile b/initrd/etc/Makefile
index f811d68cfc..afc8ecb43f 100644
--- a/initrd/etc/Makefile
+++ b/initrd/etc/Makefile
@@ -1,4 +1,4 @@
-ETC_SCRIPTS=	rc rc.lvm2 rcmount_crypt rcmount_tcplay
+ETC_SCRIPTS=	rc rc.lvm2 rcmount_crypt
 ETC_FILES=	${.CURDIR}/motd \
 		${.CURDIR}/termcap \
 		${.CURDIR}/../../etc/group \
diff --git a/initrd/rescue.libcrypto/Makefile b/initrd/rescue.libcrypto/Makefile
index 350dc11676..fbcb9631b7 100644
--- a/initrd/rescue.libcrypto/Makefile
+++ b/initrd/rescue.libcrypto/Makefile
@@ -40,8 +40,7 @@ CRUNCH_PROGS_sbin=	\
 	md5		\
 	hammer		\
 	hammer2		\
-	ping6		\
-	tcplay
+	ping6
 
 CRUNCH_ALIAS_md5= rmd160 sha1 sha256 sha512
 
@@ -57,7 +56,7 @@ CRUNCH_SRCDIRS+= gnu/sbin
 CRUNCH_PATH_gnu/sbin= ${.CURDIR}/../..
 CRUNCH_PROGS_gnu/sbin= cryptsetup
 
-CRUNCH_LIBS+= -ldm -lprop  # tcplay, cryptsetup
+CRUNCH_LIBS+= -ldm -lprop  # cryptsetup
 CRUNCH_LIBS+= -lpcap  # wpa_supplicant
 CRUNCH_LIBS+= -lhammer  # hammer
 CRUNCH_LIBS+= -ldmsg  # hammer2
diff --git a/lib/Makefile b/lib/Makefile
index 4e24ed1cc1..0cafe52b47 100644
--- a/lib/Makefile
+++ b/lib/Makefile
@@ -87,7 +87,6 @@ SUBDIR=	${SUBDIR_ORDERED} \
 	${_libsmdb} \
 	${_libsmutil} \
 	libstdbuf \
-	libtcplay \
 	libtelnet \
 	libu4bhid \
 	libvgl \
diff --git a/sbin/Makefile b/sbin/Makefile
index 7c277bb4f4..02f150423b 100644
--- a/sbin/Makefile
+++ b/sbin/Makefile
@@ -97,7 +97,6 @@ SUBDIR=	adjkerntz \
 	svc \
 	swapon \
 	sysctl \
-	tcplay \
 	tunefs \
 	udevd \
 	umount \
diff --git a/sbin/cryptdisks/Makefile b/sbin/cryptdisks/Makefile
index 3af45a0ea9..784a030617 100644
--- a/sbin/cryptdisks/Makefile
+++ b/sbin/cryptdisks/Makefile
@@ -4,8 +4,8 @@ NOSHARED=	YES
 
 SRCS+=		cryptdisks.c safe_mem.c
 
-LDADD=		-lcryptsetup -lluks -ldm -ltcplay -lprop -lutil
-DPADD=		${LIBCRYPTSETUP} ${LIBLUKS} ${LIBDM} ${LIBTCPLAY}
+LDADD=		-lcryptsetup -lluks -ldm -lprop -lutil
+DPADD=		${LIBCRYPTSETUP} ${LIBLUKS} ${LIBDM}
 DPADD+=		${LIBPROP} ${LIBUTIL}
 
 DPADD+=		${LIBCRYPTO}
diff --git a/sbin/cryptdisks/cryptdisks.c b/sbin/cryptdisks/cryptdisks.c
index 573cf6547a..f7874ca5f3 100644
--- a/sbin/cryptdisks/cryptdisks.c
+++ b/sbin/cryptdisks/cryptdisks.c
@@ -41,7 +41,6 @@
 #include <err.h>
 
 #include <libcryptsetup.h>
-#include <tcplay_api.h>
 
 #include "safe_mem.h"
 
@@ -284,7 +283,6 @@ static int
 entry_parser(char **tokens, char **options, int type)
 {
 	struct crypt_options co;
-	tc_api_task tcplay_task;
 	struct generic_opts go;
 	int r, i, error, isluks;
 
@@ -311,17 +309,14 @@ entry_parser(char **tokens, char **options, int type)
 	generic_opts_to_luks(&co, &go);
 
 	/*
-	 * Check whether the device is a LUKS-formatted device; otherwise
-	 * we assume its a TrueCrypt volume.
+	 * Check whether the device is a LUKS-formatted device
 	 */
 	isluks = !crypt_isLuks(&co);
 
 	if (!isluks) {
-		if ((error = tc_api_init(0)) != 0) {
-			fprintf(stderr, "crypttab: line %d: tc_api could not "
-			    "be initialized\n", line_no);
-			return 1;
-		}
+		fprintf(stderr, "crypttab: line %d: not a LUKS-formatted device\n",
+		    line_no);
+		return 1;
 	}
 
 	if (type == CRYPTDISKS_STOP) {
@@ -335,33 +330,6 @@ entry_parser(char **tokens, char **options, int type)
 
 			/* Actually close the device */
 			crypt_remove_device(&co);
-		} else {
-			/* Assume tcplay volume */
-			if ((tcplay_task = tc_api_task_init("unmap")) == NULL) {
-				fprintf(stderr, "tc_api_task_init failed.\n");
-				goto tcplay_err;
-			}
-			if ((error = tc_api_task_set(tcplay_task, "dev", go.device))) {
-				fprintf(stderr, "tc_api_task_set dev failed\n");
-				goto tcplay_err;
-			}
-			if ((error = tc_api_task_set(tcplay_task, "map_name",
-			    go.map_name))) {
-				fprintf(stderr, "tc_api_task_set map_name failed\n");
-				goto tcplay_err;
-			}
-			if ((error = tc_api_task_do(tcplay_task))) {
-				fprintf(stderr, "crypttab: line %d: device %s "
-				    "could not be unmapped: %s\n",
-				    line_no, go.device,
-				    tc_api_task_get_error(tcplay_task));
-				goto tcplay_err;
-			}
-			if ((error = tc_api_task_uninit(tcplay_task))) {
-				fprintf(stderr, "tc_api_task_uninit failed\n");
-				goto tcplay_err;
-			}
-
 		}
 	} else if (type == CRYPTDISKS_START) {
 		/* Open the device */
@@ -372,73 +340,10 @@ entry_parser(char **tokens, char **options, int type)
 				    line_no, co.device);
 				return 1;
 			}
-		} else {
-			if ((tcplay_task = tc_api_task_init("map")) == NULL) {
-				fprintf(stderr, "tc_api_task_init failed.\n");
-				goto tcplay_err;
-			}
-			if ((error = tc_api_task_set(tcplay_task, "dev", go.device))) {
-				fprintf(stderr, "tc_api_task_set dev failed\n");
-				goto tcplay_err;
-			}
-			if ((error = tc_api_task_set(tcplay_task, "map_name",
-			    go.map_name))) {
-				fprintf(stderr, "tc_api_task_set map_name failed\n");
-				goto tcplay_err;
-			}
-			if ((error = tc_api_task_set(tcplay_task, "interactive",
-			    (go.passphrase != NULL) ? 0 : 1))) {
-				fprintf(stderr, "tc_api_task_set map_name failed\n");
-				goto tcplay_err;
-			}
-			if ((error = tc_api_task_set(tcplay_task, "retries",
-			    go.ntries))) {
-				fprintf(stderr, "tc_api_task_set map_name failed\n");
-				goto tcplay_err;
-			}
-			if ((error = tc_api_task_set(tcplay_task, "timeout",
-			    go.timeout))) {
-				fprintf(stderr, "tc_api_task_set map_name failed\n");
-				goto tcplay_err;
-			}
-
-			if (go.passphrase != NULL) {
-				if ((error = tc_api_task_set(tcplay_task, "passphrase",
-				    go.passphrase))) {
-					fprintf(stderr, "tc_api_task_set map_name failed\n");
-					goto tcplay_err;
-				}
-			}
-
-			for (i = 0; i < go.nkeyfiles; i++) {
-				if ((error = tc_api_task_set(tcplay_task, "keyfiles",
-				    go.keyfiles[i]))) {
-					fprintf(stderr, "tc_api_task_set keyfile failed\n");
-					goto tcplay_err;
-				}
-			}
-			if ((error = tc_api_task_do(tcplay_task))) {
-				fprintf(stderr, "crypttab: line %d: device %s "
-				    "could not be mapped/opened: %s\n",
-				    line_no, go.device,
-				    tc_api_task_get_error(tcplay_task));
-				goto tcplay_err;
-			}
-			if ((error = tc_api_task_uninit(tcplay_task))) {
-				fprintf(stderr, "tc_api_task_uninit failed\n");
-				goto tcplay_err;
-			}
 		}
 	}
 
-	if (!isluks)
-		tc_api_uninit();
-
 	return 0;
-
-tcplay_err:
-	tc_api_uninit();
-	return 1;
 }
 
 static int
diff --git a/share/man/man4/Makefile b/share/man/man4/Makefile
index 22aef48a82..71494b900b 100644
--- a/share/man/man4/Makefile
+++ b/share/man/man4/Makefile
@@ -70,7 +70,6 @@ MAN=	aac.4 \
 	corepower.4 \
 	coretemp.4 \
 	cpuctl.4 \
-	crypto.4 \
 	cue.4 \
 	cxm.4 \
 	da.4 \
@@ -108,7 +107,6 @@ MAN=	aac.4 \
 	gpio_acpi.4 \
 	gpio_intel.4 \
 	gre.4 \
-	hifn.4 \
 	hpt27xx.4 \
 	hptiop.4 \
 	hptmv.4 \
@@ -231,7 +229,6 @@ MAN=	aac.4 \
 	oce.4 \
 	ohci.4 \
 	orm.4 \
-	padlock.4 \
 	pass.4 \
 	pccard.4 \
 	pccbb.4 \
@@ -266,7 +263,6 @@ MAN=	aac.4 \
 	run.4 \
 	runfw.4 \
 	sa.4 \
-	safe.4 \
 	sbp.4 \
 	sbsh.4 \
 	screen.4 \
@@ -337,7 +333,6 @@ MAN=	aac.4 \
 	txp.4 \
 	uark.4 \
 	ubsa.4 \
-	ubsec.4 \
 	ubser.4 \
 	ubt.4 \
 	uchcom.4 \
@@ -437,7 +432,6 @@ MLINKS+=bnx.4 if_bnx.4
 MLINKS+=bridge.4 if_bridge.4
 MLINKS+=bwn.4 if_bwn.4
 MLINKS+=cdce.4 if_cdce.4
-MLINKS+=crypto.4 cryptodev.4
 MLINKS+=cue.4 if_cue.4
 MLINKS+=dc.4 if_dc.4
 MLINKS+=disc.4 if_disc.4
diff --git a/share/man/man9/Makefile b/share/man/man9/Makefile
index 13d65b234b..447eb78f4d 100644
--- a/share/man/man9/Makefile
+++ b/share/man/man9/Makefile
@@ -447,19 +447,10 @@ MLINKS+=crit_enter.9 crit_enter_gd.9 \
 	crit_enter.9 crit_exit_id.9
 MLINKS+=crypto.9 crypto_dispatch.9 \
 	crypto.9 crypto_done.9 \
-	crypto.9 crypto_find_device_byhid.9 \
-	crypto.9 crypto_find_driver.9 \
-	crypto.9 crypto_freereq.9 \
 	crypto.9 crypto_freesession.9 \
-	crypto.9 crypto_getcaps.9 \
 	crypto.9 crypto_get_driverid.9 \
-	crypto.9 crypto_getreq.9 \
-	crypto.9 crypto_kdispatch.9 \
-	crypto.9 crypto_kdone.9 \
-	crypto.9 crypto_kregister.9 \
 	crypto.9 crypto_newsession.9 \
 	crypto.9 crypto_register.9 \
-	crypto.9 crypto_unblock.9 \
 	crypto.9 crypto_unregister.9 \
 	crypto.9 crypto_unregister_all.9
 MLINKS+=DB_COMMAND.9 DB_COMMAND_FLAG.9 \
diff --git a/share/mk/bsd.libnames.mk b/share/mk/bsd.libnames.mk
index 436a1d43e5..9306f44314 100644
--- a/share/mk/bsd.libnames.mk
+++ b/share/mk/bsd.libnames.mk
@@ -77,7 +77,6 @@ LIBSMB?=	${DESTDIR}${LIBDIR}/libsmb.a
 LIBSSH?=	${DESTDIR}${LIBDIR}/priv/libprivate_ssh.a
 LIBSSL?=	${DESTDIR}${LIBDIR}/priv/libprivate_ssl.a
 LIBSTDBUF?=	${DESTDIR}${LIBDIR}/libstdbuf.a
-LIBTCPLAY?=	${DESTDIR}${LIBDIR}/libtcplay.a
 LIBUSBHID?=	${DESTDIR}${LIBDIR}/libusbhid.a
 LIBUSB?=	${DESTDIR}${LIBDIR}/libusb.a
 LIBUTIL?=	${DESTDIR}${LIBDIR}/libutil.a
diff --git a/sys/conf/files b/sys/conf/files
index 5b6757b66e..82d5788fe8 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -1216,7 +1216,6 @@ dev/misc/pps/pps.c		optional pps
 dev/disk/vpo/vpo.c		optional vpo
 dev/disk/vpo/vpoio.c	optional vpo
 dev/crypto/rndtest/rndtest.c	optional rndtest
-dev/crypto/safe/safe.c		optional safe
 dev/netif/sbsh/if_sbsh.c	optional sbsh
 dev/disk/sdhci/sdhci.c		optional sdhci
 dev/disk/sdhci/sdhci_if.m	optional sdhci
@@ -2245,10 +2244,9 @@ libprop/prop_object.c			standard
 libprop/prop_stack.c			standard
 libprop/prop_string.c			standard
 libprop/prop_rb.c			standard
+crypto/crypto_mod.c			optional crypto
+crypto/crypto_cipher.c			optional crypto
 crypto/blake2/blake2s.c			optional crypto
-crypto/blowfish/bf_skey.c		optional crypto
-crypto/camellia/camellia.c		optional crypto
-crypto/camellia/camellia-api.c		optional crypto
 crypto/chacha20/chacha.c		optional crypto
 crypto/chachapoly.c			optional crypto
 crypto/curve25519/curve25519.c		optional crypto
@@ -2259,25 +2257,14 @@ crypto/rc4/rc4.c			optional crypto
 crypto/rijndael/rijndael-alg-fst.c	optional crypto
 crypto/rijndael/rijndael-api-fst.c	optional crypto
 crypto/rijndael/rijndael-api.c		optional crypto
+crypto/rmd160/rmd160.c			optional crypto
 crypto/sha1.c				optional crypto
 crypto/sha2/sha2.c			standard
 crypto/siphash/siphash.c		optional crypto
-crypto/twofish/twofish.c		optional crypto
-crypto/serpent/serpent.c		optional crypto
-net/zlib.c				optional crypto
-opencrypto/cast.c			optional crypto
-opencrypto/criov.c			optional crypto
-opencrypto/crypto.c			optional crypto
-opencrypto/cryptodev.c			optional cryptodev
-opencrypto/cryptodev_if.m		optional crypto
-opencrypto/cryptosoft.c			optional crypto
-opencrypto/deflate.c			optional crypto
-opencrypto/gmac.c			optional crypto
-opencrypto/rmd160.c			optional crypto
-opencrypto/skipjack.c			optional crypto
-opencrypto/xform.c			optional crypto
-dev/crypto/hifn/hifn7751.c		optional hifn
-dev/crypto/ubsec/ubsec.c		optional ubsec
+crypto/aesni/aesni.c			optional crypto
+crypto/aesni/aesencdec_x86_64.S		optional crypto
+crypto/aesni/aeskeys_x86_64.S		optional crypto
+
 # drm_agpsupport.c must be included if CONFIG_AGP is set
 #dev/drm/drm_agpsupport.c		optional drm compile-with "${NORMAL_C} -include $S/dev/drm/kconfig.h ${WERROR}"
 dev/drm/drm_atomic.c			optional drm compile-with "${NORMAL_C} -include $S/dev/drm/kconfig.h ${WERROR}"
diff --git a/sys/conf/kmod.mk b/sys/conf/kmod.mk
index 764df1c766..3ffae6dce0 100644
--- a/sys/conf/kmod.mk
+++ b/sys/conf/kmod.mk
@@ -350,7 +350,7 @@ MFILES?= kern/bus_if.m kern/device_if.m bus/iicbus/iicbb_if.m \
     dev/sound/pcm/feeder_if.m dev/sound/pcm/mixer_if.m \
     dev/sound/midi/mpu_if.m dev/sound/midi/mpufoi_if.m \
     dev/sound/midi/synth_if.m  \
-    libiconv/iconv_converter_if.m dev/agp/agp_if.m opencrypto/cryptodev_if.m \
+    libiconv/iconv_converter_if.m dev/agp/agp_if.m \
     bus/mmc/mmcbus_if.m bus/mmc/mmcbr_if.m \
     dev/virtual/virtio/virtio/virtio_bus_if.m \
     dev/misc/backlight/backlight_if.m dev/misc/coremctl/coremctl_if.m kern/cpu_if.m \
diff --git a/sys/conf/options b/sys/conf/options
index fd3c0d6bcd..4d8dc7a748 100644
--- a/sys/conf/options
+++ b/sys/conf/options
@@ -504,21 +504,6 @@ PCFCLOCK_MAX_RETRIES	opt_pcfclock.h
 # Network device queue based polling
 IFPOLL_ENABLE		opt_ifpoll.h
 
-# options for ubsec driver
-UBSEC_DEBUG		opt_ubsec.h
-UBSEC_RNDTEST		opt_ubsec.h
-UBSEC_NO_RNG		opt_ubsec.h
-
-# options for hifn driver
-HIFN_DEBUG		opt_hifn.h
-HIFN_RNDTEST		opt_hifn.h
-HIFN_NO_RNG		opt_hifn.h
-
-# options for safenet driver
-SAFE_DEBUG		opt_safe.h
-SAFE_NO_RNG		opt_safe.h
-SAFE_RNDTEST		opt_safe.h
-
 # KTR options
 KTR				opt_global.h
 KTR_ENTRIES			opt_global.h
